//+------------------------------------------------------------------+
//|                                                 agTickVolume.mq4 |
//|                                Copyright  2013, babayka@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, babayka@mail.ru"
#property link      "babayka@mail.ru"

#property indicator_chart_window

extern string __common__  = "__ __";
//extern int    iCalcBars = 20;
extern int    iShowBars = 5;
extern string ___view___  = "__ __";
extern color  cAboveAvgColor = MediumSeaGreen;
extern color  cBelowAvgColor = Crimson;
extern color  cAverageColor = White;
extern int    iHistFontSize = 14;
extern int    iLastFontSize = 20;
extern string sFontFace = "Arial";
extern string __corner___  = "0 -, 1 -, 2 -, 3 -";
extern int    iCorner = 0;
extern int    iInfoDistanceX = 400;
extern int    iInfoDistanceY = 100;
extern int    iInfoDistanceBetween = 70;



double dVolumeBuffer[];

int iShift = -1;
double dA;
double dB;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   int iCnt;
   int iDistance;
   int iCurFontSize;
   
   ArrayResize(dVolumeBuffer, iShowBars); 
   //SetIndexBuffer(0, dVolumeBuffer);
   //SetIndexStyle(0, DRAW_NONE);
   IndicatorShortName("agTickVolume");
   iDistance = iInfoDistanceX;
   for (iCnt=0;iCnt < iShowBars; iCnt++) {
      if (iCnt==0) iCurFontSize = iLastFontSize; else iCurFontSize = iHistFontSize;
      ObjectCreate("agTVValue"+(iShowBars-iCnt-1), OBJ_LABEL, 0, 0, 0);
      ObjectSet("agTVValue"+(iShowBars-iCnt-1), OBJPROP_CORNER, iCorner);
      ObjectSet("agTVValue"+(iShowBars-iCnt-1), OBJPROP_XDISTANCE, iDistance);
      ObjectSet("agTVValue"+(iShowBars-iCnt-1), OBJPROP_YDISTANCE, iInfoDistanceY);
      ObjectSetText("agTVValue"+(iShowBars-iCnt-1), "0.0", iCurFontSize, sFontFace, cAverageColor);
      iDistance = iDistance + iInfoDistanceBetween;
      if (iCnt == (iShowBars-1))
         iDistance = iDistance + iInfoDistanceBetween;
   }

   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   int iCnt;
   for (iCnt=0;iCnt < iShowBars; iCnt++) {
      ObjectDelete("agTVValue"+iCnt);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   color cMsgColor;
   string sTV;
   int iCnt;
   int iCurFontSize;
   
   RefreshRates();
   TickVolumeDiff();
   
   for (iCnt=0;iCnt < iShowBars; iCnt++) {
      if (dVolumeBuffer[iCnt] > 1.0)
         cMsgColor = cAboveAvgColor;
      else if (dVolumeBuffer[iCnt] < 1.0)
         cMsgColor = cBelowAvgColor; 
      if (iCnt==0) iCurFontSize = iLastFontSize; else iCurFontSize = iHistFontSize;
      sTV = DoubleToStr(NormalizeDouble(dVolumeBuffer[iCnt], 1), 1);
      ObjectSetText("agTVValue"+iCnt, sTV, iCurFontSize, sFontFace, cMsgColor);
   }
   return(0);
}

void TickVolumeDiff() {
   int iLocalShift;
   int iMaxBars = Period()*iShowBars;
   int iShift = -1;
   
   //for (int iCnt = 0; iCnt < iBars(Symbol(), PERIOD_M1); iCnt++) {
   for (int iCnt = 0; iCnt < iMaxBars; iCnt++) {
      iLocalShift = iBarShift(Symbol(), Period(), iTime(Symbol(), PERIOD_M1, iCnt), TRUE);
      if (iShift != iLocalShift) {
         dA = 0;
         dB = 0;
         dVolumeBuffer[iLocalShift] = 0;
      }
      if (iLocalShift != -1) {
         if (iClose(Symbol(), PERIOD_M1, iCnt) > iClose(Symbol(), PERIOD_M1, iCnt + 1)) dA += iVolume(Symbol(), PERIOD_M1, iCnt);
         if (iClose(Symbol(), PERIOD_M1, iCnt) < iClose(Symbol(), PERIOD_M1, iCnt + 1)) dB -= iVolume(Symbol(), PERIOD_M1, iCnt);
         if (iClose(Symbol(), PERIOD_M1, iCnt) == iClose(Symbol(), PERIOD_M1, iCnt + 1)) {
            dA += iVolume(Symbol(), PERIOD_M1, iCnt) / 2.0;
            dB -= iVolume(Symbol(), PERIOD_M1, iCnt) / 2.0;
         }
      }
      dVolumeBuffer[iLocalShift] = (dA + dB) / 2.0;
      iShift = iLocalShift;
   }
}
//+------------------------------------------------------------------+